#include< reg51.h>
void Floor(unsigned int floor);    //Lift Started
void DownFloor(unsigned int floor,char c); //Bringing Back Lift

sbit rw =P3^0;   //Read/Write Pin
sbit en =P3^1;   //Enable for First 80 Characters
sbit rs =P3^2;   //Register select (RS)

char sign;
char a[8]={0x04,0x0E,0x15,0x04,0x04,0x04,0x04,0x00};//Up Arrow	
char b[8]={0x04,0x04,0x04,0x04,0x15,0x0E,0x04,0x00};//Down Arrow

void delay(unsigned int time)  //Time delay function
{
unsigned int i,j;
for(i=0;i< time;i++)
for(j=0;j< 5;j++);
}

void Timedelay(unsigned int time)  //Time delay function
{
unsigned int i,j;
for(i=0;i< time;i++)
for(j=0;j< 25;j++);
}

             //Function for sending values to the command register of LCD
void lcdcmd(unsigned char value)  
{
P1=value;
rs = 0;
rw = 0;
en = 1;             		
delay(10);
en=0;
delay(10);
}

             //Function for sending values to the data register of LCD
void display(unsigned char value)  
{
P1=value;
rs = 1;
rw = 0;
en = 1;           		
delay(10);
en=0;
delay(10);
}
             //function to initialize the registers and pins of LCD
             //always use with every lcd of hitachi
void lcdint(void)         
{		
delay(5000);
display(0x30);
delay(4500);
display(0x30);
delay(300);
display(0x30);
delay(650);
lcdcmd(0x38);	//Character font = 5x8
delay(50);
lcdcmd(0x0C);	//Display on Cursor Off
delay(50);
lcdcmd(0x01);	//Clear Lcd
delay(50);
lcdcmd(0x06);	//Entry Mode
delay(50);
}

void main()
{
unsigned int i=0,ButtonP=0,count=0,floor=0;
char st[]="Enter Floor....";

P0=0xFF;//Port-0 as INPUT  (Buttons)
P1=0x00;//Port-1 as OUTPUT (16x2 Lcd Connected)
P2=0x00;//Port-2 as OUTPUT (Led Bar)
P3=0xF0;//Port-3 Upper Bits as Input and Lower as Output 

lcdint();		  //Initializing hd44780 lcd controller              

lcdcmd(0x48);	   //Creating custom character in CG-RAM 
for(i=0;i<8;i++)
display(a[i]);

lcdcmd(0x50);	   //Creating custom character in CG-RAM 
for(i=0;i<8;i++)
display(b[i]);

while(1){
	i=0;ButtonP=0;count=0;floor=0;sign='a';
	lcdcmd(0x01);
	lcdcmd(0x80);//Start From First Line of 16x2 Lcd
while(st[count]!='\0')
	{
		display(st[count]);
		count++;	
	}
	lcdcmd(0x0F);//Display on Cursor Blinlking
	lcdcmd(0xC0);//Cursor on Second line
while(sign!='b'){
for(i=0;i<8;i++)   //Checking lift button status
{
	ButtonP=((P0>>i)& 1);

	if(ButtonP==0){
	  Floor(i+1);
	}
 //display(1);	   //Displaying Up-Arrow
	else{

	}
 //display(2);	   //Displaying Down-Arrow
}

  }

}
}

void Floor(unsigned int floor){
unsigned int i=0,j=0;
char st[]="G-UP....",c=0x31;
lcdcmd(0x01);//Clear Lcd
//Uncomment If you Need(It Looks Good :-D)
//lcdcmd(0xC0);//On Second Line Display UP-Arrow
//display(0x01);//Display up Arrow
lcdcmd(0x80);//Print on First Line

while(floor!=i){

	while(st[j]!='\0')
	{
		display(st[j]);
		j++;	
	}
	display(c);

P2=P2<<1 | 1;
c=c+0x01;
Timedelay(10000);
i++;
}
  Timedelay(10000);//After this Delay bring Back Lift to Ground
  Timedelay(10000);
  DownFloor(floor,c-0x01);//Bring Back Lift
}

void DownFloor(unsigned int floor,char c){
unsigned int i=0,j=0;
char st[]="G-Down..";
lcdcmd(0x01);//Clear Lcd
//Uncomment If you Need(It Looks Good :-D)
//lcdcmd(0xC0);//On Second Line Display Down-Arrow
//display(0x02);//Display Down Arrow
lcdcmd(0x80);//Print on First Line

while(floor!=i){
	while(st[j]!='\0')
	{
		display(st[j]);
		j++;	
	}
	display(c);
P2=P2>>1;
c=c-0x01;
Timedelay(10000);
i++;
}
sign='b';
}
